#!/usr/bin/env ruby

require 'socket'
require 'ssl'
require 'getopts'

include SSL

getopts "v", "C:", "p:2000", "k:", "c:"

host = ARGV[0] || "localhost"

s = TCPSocket.new(host, $OPT_p)
STDERR.print "connect to #{s.peeraddr[3]}.\n"

ssl = SSLSocket.new(s, $OPT_k, $OPT_c)
ssl.verify_mode = SSL_VERIFY_PEER if $OPT_v
if ca_file = $OPT_C
  ssl.ca_file = ca_file
  ssl.ca_path, = File.split(ca_file)
end
STDERR.print "SSLSocket initialized.\n"

ssl.connect
STDERR.print "SSLSocket connected.\n"

if peer_cert = ssl.peer_cert
  STDERR.print "serialNumber = #{peer_cert.serialNumber}\n"
  STDERR.print "subject      = #{peer_cert.subject}\n"
  STDERR.print "issuer       = #{peer_cert.issuer}\n"
  STDERR.print "notBefore    = #{peer_cert.notBefore}\n"
  STDERR.print "notAfter     = #{peer_cert.notAfter}\n"
end

while line = gets
  ssl.write line
end

ssl.close
s.close
