#!/usr/bin/env ruby

require 'socket'
require 'ssl'
require 'getopts'

include SSL

getopts "v", "C:", "p:2000", "k:sample.key", "c:sample.crt"

p [ $OPT_p, $OPT_k, $OPT_c ]
ns = TCPServer.new($OPT_p)
loop do
  begin
    s = ns.accept
    STDERR.print "connect from #{s.peeraddr[3]}.\n"

    ssl = SSLSocket.new(s, $OPT_k, $OPT_c)
    if $OPT_v
      ssl.verify_mode = SSL_VERIFY_PEER | SSL_VERIFY_FAIL_IF_NO_PEER_CERT
    end
    if ca_file = $OPT_C
      ssl.ca_file = ca_file
      ssl.ca_path, = File.split(ca_file)
    end
    STDERR.print "SSLSocket initialized.\n"

    ssl.accept
    STDERR.print "SSLSocket accepted.\n"
  rescue 
    print $!, "\n"
    next
  end

  if peer_cert = ssl.peer_cert
    STDERR.print "cert.serialNumber = #{peer_cert.serialNumber}\n"
    STDERR.print "cert.subject      = #{peer_cert.subject}\n"
    STDERR.print "cert.issuer       = #{peer_cert.issuer}\n"
    STDERR.print "cert.notBefore    = #{peer_cert.notBefore}\n"
    STDERR.print "cert.notAfter     = #{peer_cert.notAfter}\n"
  end

  Thread.start{
    while line = ssl.gets
      p line
    end
    STDERR.print "connection closed.\n"
    ssl.close
    s.close
  }
end
