#!/usr/local/bin/ruby

require 'net/https'
require 'getopts'

getopts nil, 'p:'

uri = ARGV[0]
if %r!(https?)://(.*?)(?::(\d+))?(/.*)! =~ uri
  scheme = $1
  host   = $2
  port   = $3 ? $3.to_i : Socket.getservbyname(scheme)
  path   = $4 || "/"
else
  STDERR.print "Invalid URI.\n"
  exit 2
end

# parse HTTP_PROXY environment variable.
if proxy = ENV['HTTP_PROXY']
  if %r!(http)://(.*?)(?::(\d+))?(/.*)! =~ proxy
    p_scheme = $1
    p_host   = $2
    p_port   = $3 ? $3.to_i : Socket.getservbyname(p_scheme)
  else
    STDERR.print "Invalid HTTP_PROXY.\n"
    exit 2
  end
end

h = Net::HTTP.new(host, port, p_host, p_port)
h.use_ssl = true if scheme == "https"
h.get2(path){ |resp|
  if peer_cert = h.peer_cert
    STDERR.print "serialNumber = #{peer_cert.serialNumber}\n"
    STDERR.print "subject      = #{peer_cert.subject}\n"
    STDERR.print "issuer       = #{peer_cert.issuer}\n"
    STDERR.print "notBefore    = #{peer_cert.notBefore}\n"
    STDERR.print "notAfter     = #{peer_cert.notAfter}\n"
  end

  print resp.body
}

